<?
// Ralise des commandes SQL sur une base de donnes ODBC (c)PCo2005

class ODBC {
  var $dsn; // nom du lien ODBC
  var $usr; // nom d'utilisateur
  var $psw;	// mot de passe
  
  // Constructeur
  function ODBC($uneCnnStr) {
    $this->dsn = $uneCnnStr['dsn'];
    $this->usr = $uneCnnStr['usr'];
    $this->psw = $uneCnnStr['psw'];
  }
  
  // Ralise la connexion  la BD
  function connecter() {
  	$idCnn = odbc_connect($this->dsn, $this->usr, $this->psw)
  	 or exit("<h1>Erreur de connexion  la base de donnes !</h1>");
  	return $idCnn;
  }
	
  // Extrait des enregistrements dans un tableau  2 dimensions (ligne, colonne)
  function _extraire($uneReqSQL) {
  	$idCnn = $this->connecter();
  	$idJeuEnr = odbc_exec($idCnn, $uneReqSQL);
  	$je = array();
    while ($champs=odbc_fetch_array($idJeuEnr)){
  		$je[] = $champs;
  	}
  	odbc_close($idCnn);
  	return $je;
  }
    //nouvelle version en test
    function extraire($uneReqSQL) {
  	$idCnn = $this->connecter();
  	$idJeuEnr = odbc_exec($idCnn, $uneReqSQL);
  	$je = array();
      while ($champs=odbc_fetch_array($idJeuEnr)){
  		$je[] = $champs;
  	}
  	odbc_close($idCnn);
  	return $je;
  }

  // Extrait uniquement la 1re colonne
  function extraire_1col($uneReqSQL) {
  	$je = array();
  	$je = $this->extraire($uneReqSQL);
  	if (count($je)==1) {
      $k=array_keys($je[0]);
      return $je[0][$k[0]];
   }
  }

  // Extrait uniquement la 1re ligne
  function extraire_1lig($uneReqSQL) {
  	$je = array();
  	$je = $this->extraire($uneReqSQL);
  	if (count($je)==1) return $je[0];
  }

  // Excute une requte Action - INSERT, UPDATE, DELETE
  // Retourne un message d'erreur ventuellement
  function executer($uneReqSQL) {
  	$idCnn=$this->connecter();
  	$ret=@odbc_exec($idCnn, $uneReqSQL);
  	odbc_close($idCnn);
  	if (!$ret) return odbc_errormsg();
  }

}
